#!/usr/bin/env python

#mudar todos os 7 para 9

from Pegasus.DAX3 import *
import sys
import os

# Create a abstract dag
dax = ADAG("example_workflow")





#################################################
# FILE
#################################################
# IMPORT 

totalFiles = 4 # 2 files from google
filePerTask = 1; # 1 file per task
additionalFile = 0; 
initial = 0
limit = 4

number_files = list(range(0, totalFiles))
files_import = []

for x in number_files:
	# Add input file to the DAX-level replica catalog
	filename = "part-"+str(x).zfill(5)+"-of-00500.csv.gz"

	files_import.append(File(filename))
	files_import[x].addPFN(PFN("file:///mnt/google/clusterdata-2011-2/task_events/" + filename, "local"))
	dax.addFile(files_import[x])


config_1_import = []
for x in range(0, limit):
	filename1 = "ConfigCSVGZ_ImportTask_"+str(x)+".py"
	config_1_import.append(File(filename1))
	config_1_import[x].addPFN(PFN("file://" + os.getcwd() + "/import_"+str(x)+"/ConfigCSVGZ_ImportTask_"+str(x)+".py", "local"))
	dax.addFile(config_1_import[x])


config_2_import = []
for x in range(0, limit):
	filename2 = "ConfigMongoDB_ImportTask_"+str(x)+".py"
	config_2_import.append(File(filename2))
	config_2_import[x].addPFN(PFN("file://" + os.getcwd() + "/import_"+str(x)+"/ConfigMongoDB_ImportTask_"+str(x)+".py", "local"))
	dax.addFile(config_2_import[x])


#################################################
# CALCULATE

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 32
number_files = list(range(0, totalFiles))
directory = "calculate_"
taskName = "CalculateRatioCpuMemory"
fileConfig = "ConfigMongoDB_Task_"

config_calculate = []
for x in range(0, limit):
	filename2 = fileConfig +str(x)+".py"
	config_calculate.append(File(filename2))
	config_calculate[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+filename2, "local"))
	dax.addFile(config_calculate[x])

#################################################
# AVERAGE

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 9
number_files = list(range(0, totalFiles))
directory = "average_"
taskName = "AverageRatioEvent"
fileConfig = "ConfigMongoDB_Average_"

config_average = []
for x in range(0, limit):
	filename2 = fileConfig +str(x)+".py"
	config_average.append(File(filename2))
	config_average[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+filename2, "local"))
	dax.addFile(config_average[x])

#################################################
# MAXMIN

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 1


directory = "maxmin_"
taskName = "MaxMinRatioEvent"
fileConfig = "ConfigMongoDB_MaxMin_"

config_maxmin = []
for x in range(0, limit):
	filename2 = fileConfig +str(x)+".py"
	config_maxmin.append(File(filename2))
	config_maxmin[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+filename2, "local"))
	dax.addFile(config_maxmin[x])


#################################################
# EXECUTABLE
#################################################
# IMPORT 

totalFiles = 4 # 2 files from google
filePerTask = 1; # 1 file per task
additionalFile = 0; 
initial = 0
limit = 4
directory = "import_"
taskName = "ImportTask"
number_files = list(range(0, totalFiles))
imports_import = []
for x in range(0, limit):
	imports_import.append(Executable(namespace="example_workflow", name=directory+str(x), version="1.0", \
                     os="linux", arch="x86_64", installed=False))
	imports_import[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+taskName+"_"+str(x)+".py", "condorpool"))
	dax.addExecutable(imports_import[x])
	
#################################################
# CALCULATE


totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 32
number_files = list(range(0, totalFiles))
directory = "calculate_"
taskName = "CalculateRatioCpuMemory"
fileConfig = "ConfigMongoDB_Task_"

imports_calculate = []
for x in range(0, limit):
	imports_calculate.append(Executable(namespace="example_workflow", name=directory+str(x), version="1.0", \
                     os="linux", arch="x86_64", installed=False))
	imports_calculate[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+taskName+"_"+str(x)+".py", "condorpool"))
	dax.addExecutable(imports_calculate[x]) 

#################################################
# AVERAGE

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 9
number_files = list(range(0, totalFiles))
directory = "average_"
taskName = "AverageRatioEvent"
fileConfig = "ConfigMongoDB_Average_"

imports_average = []
for x in range(0, limit):
	imports_average.append(Executable(namespace="example_workflow", name=directory+str(x), version="1.0", \
                     os="linux", arch="x86_64", installed=False))
	imports_average[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+taskName+"_"+str(x)+".py", "condorpool"))
	dax.addExecutable(imports_average[x])




#################################################
# MAXMIN


totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 1


directory = "maxmin_"
taskName = "MaxMinRatioEvent"
fileConfig = "ConfigMongoDB_MaxMin_"


imports_maxmin = []
for x in range(0, limit):
	
	imports_maxmin.append(Executable(namespace="example_workflow", name=directory+str(x), version="1.0", \
                     os="linux", arch="x86_64", installed=False))
	imports_maxmin[x].addPFN(PFN("file://" + os.getcwd() + "/"+directory+str(x)+"/"+taskName+"_"+str(x)+".py", "condorpool"))
	dax.addExecutable(imports_maxmin[x])


#################################################
# JOB
#################################################
# IMPORT 

totalFiles = 4 # 2 files from google
filePerTask = 1; # 1 file per task
additionalFile = 0; 
initial = 0
limit = 4

number_files = list(range(0, totalFiles))


jobs_import = []
# Add the hello job
for x in range(0, limit):
	jobs_import.append(Job(namespace="example_workflow", name="import_"+str(x), version="1.0"))

	if (additionalFile > 0):
		totalFile = filePerTask + 1;
		additionalFile = additionalFile -1;
	else:
		totalFile = filePerTask;
#	print str(totalFile)+" - "+ str(initial) + " - "+ str(initial+totalFile)
	for y in range(initial, (initial+totalFile)):
		jobs_import[x].uses(files_import[y], link=Link.INPUT)


	jobs_import[x].uses(config_1_import[x], link=Link.INPUT)
	jobs_import[x].uses(config_2_import[x], link=Link.INPUT)

	dax.addJob(jobs_import[x])

	initial = initial + totalFile


#################################################
# CALCULATE 	

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 32
number_files = list(range(0, totalFiles))
directory = "calculate_"
taskName = "CalculateRatioCpuMemory"
fileConfig = "ConfigMongoDB_Task_"

jobs_calculate = []

# Add the hello job
for x in range(0, limit):
	jobs_calculate.append(Job(namespace="example_workflow", name=directory+str(x), version="1.0"))
	jobs_calculate[x].uses(config_calculate[x], link=Link.INPUT)
	dax.addJob(jobs_calculate[x])


#################################################
# AVERAGE

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 9
number_files = list(range(0, totalFiles))
directory = "average_"
taskName = "AverageRatioEvent"
fileConfig = "ConfigMongoDB_Average_"

jobs_average = []

# Add the hello job
for x in range(0, limit):
	jobs_average.append(Job(namespace="example_workflow", name=directory+str(x), version="1.0"))
	jobs_average[x].uses(config_average[x], link=Link.INPUT)
	dax.addJob(jobs_average[x]) 

#################################################
# MAXMIN

totalFiles = 10
filePerTask = 1;
additionalFile = 0;
initial = 0
limit = 1


directory = "maxmin_"
taskName = "MaxMinRatioEvent"
fileConfig = "ConfigMongoDB_MaxMin_"

jobs_maxmin = []

# Add the hello job
for x in range(0, limit):
	jobs_maxmin.append(Job(namespace="example_workflow", name=directory+str(x), version="1.0"))
	jobs_maxmin[x].uses(config_maxmin[x], link=Link.INPUT)
	dax.addJob(jobs_maxmin[x])


# Add control-flow dependencies

#################################################
# DEPENDENCY
# dax.addDependency(Dependency(parent=hello, child=world)) hello is the var for the job hello
#################################################
# CALCULATE

#each calculate depends on all import

for x in range(0, len(jobs_import)):
	for y in range(0, len(jobs_calculate)):
		dax.addDependency(Dependency(parent=jobs_import[x], child=jobs_calculate[y]))

#################################################
# AVERAGE

#each avg depends on all calc

for x in range(0, len(jobs_calculate)):
	for y in range(0, len(jobs_average)):
		dax.addDependency(Dependency(parent=jobs_calculate[x], child=jobs_average[y]))

#################################################
# MAXMIN

#each maxmin depends on all avg

for x in range(0, len(jobs_average)):
	for y in range(0, len(jobs_maxmin)):
		dax.addDependency(Dependency(parent=jobs_average[x], child=jobs_maxmin[y]))




# Write the DAX to stdout
dax.writeXML(sys.stdout)
